import { Client, RequestHandler, MetadataBearer } from "@aws-sdk/types";

import { Client as Constructor } from "@aws-sdk/smithy-client";

import { SmithyConfiguration } from "@aws-sdk/smithy-client/dist-types/client.js";
import { HttpHandlerOptions as __HttpHandlerOptions } from "@aws-sdk/types/dist-types/http.js";
import { RegionInputConfig } from "@aws-sdk/config-resolver";
import { EndpointsInputConfig } from "@aws-sdk/config-resolver";
import { RetryInputConfig } from "@aws-sdk/middleware-retry";
import { HostHeaderInputConfig } from "@aws-sdk/middleware-host-header";
import { UserAgentInputConfig } from "@aws-sdk/middleware-user-agent";
import { DefaultsModeConfigs } from "@aws-sdk/smithy-client";

declare namespace IO {
    type Object = {};

    type Generic = typeof Symbol | any;

    interface Input extends Object {}

    interface Output extends MetadataBearer {}

    interface Configuration extends Generic, Client<any, any, any> {}
}

declare namespace Settings {
    export interface Options<Configuration> {
        requestHandler: RequestHandler<any, any, Configuration>;
        /**
         * The API version set internally by the SDK, and is
         * not planned to be used by customer code.
         * @internal
         */
        readonly apiVersion: string;
    }

    export type Resolve<$> = Settings.Options<$>
}

declare namespace Configuration {
    export type Service = typeof Constructor;
    // eslint-disable-next-line max-len
    export type Implementation = Partial<SmithyConfiguration<__HttpHandlerOptions>> & DefaultsModeConfigs & RegionInputConfig & EndpointsInputConfig & RetryInputConfig & HostHeaderInputConfig & UserAgentInputConfig & Settings.Resolve<IO.Generic>;
}

export { Constructor };
export default { Constructor };
export type { Configuration, Settings, Client, IO };
