import { Command } from "./commands";
import { Credential } from "./authorization";
declare class Commands {
    readonly tags: typeof import("@aws-sdk/client-lambda").ListTagsCommand;
    readonly policy: typeof import("@aws-sdk/client-lambda").GetPolicyCommand;
    readonly layers: typeof import("@aws-sdk/client-lambda").ListLayersCommand;
    readonly sources: typeof import("@aws-sdk/client-lambda").ListEventSourceMappingsCommand;
    readonly function: typeof import("@aws-sdk/client-lambda").GetFunctionCommand;
    readonly versions: typeof import("@aws-sdk/client-lambda").ListVersionsByFunctionCommand;
    readonly functions: typeof import("@aws-sdk/client-lambda").ListFunctionsCommand;
    readonly invocation: typeof import("@aws-sdk/client-lambda").ListFunctionEventInvokeConfigsCommand;
    readonly configuration: typeof import("@aws-sdk/client-lambda").GetFunctionConfigurationCommand;
    readonly account: typeof import("@aws-sdk/client-lambda").GetAccountSettingsCommand;
    private constructor();
    static initialize(): Commands;
}
/***
 * AWS Lambda Service Interface
 * ---
 *
 * While the `Client` defines and wraps the profile + credentials,
 * and initializes the `*.commands` attribute(s), `Service` extends
 * usage to AWS' Lambda API.
 *
 * @see {@link Constructor Lambda-Client}
 *
 * @example
 * @todo
 */
declare class Client extends Credential {
    protected readonly commands: Commands;
    constructor(profile?: string);
}
export { Client, Commands, Command };
declare const _default: {
    Client: typeof Client;
    Commands: typeof Commands;
    Command: {
        ListTagsCommand: typeof import("@aws-sdk/client-lambda").ListTagsCommand;
        GetPolicyCommand: typeof import("@aws-sdk/client-lambda").GetPolicyCommand;
        ListLayersCommand: typeof import("@aws-sdk/client-lambda").ListLayersCommand;
        ListEventSourceMappingsCommand: typeof import("@aws-sdk/client-lambda").ListEventSourceMappingsCommand;
        GetFunctionCommand: typeof import("@aws-sdk/client-lambda").GetFunctionCommand;
        ListVersionsByFunctionCommand: typeof import("@aws-sdk/client-lambda").ListVersionsByFunctionCommand;
        ListFunctionsCommand: typeof import("@aws-sdk/client-lambda").ListFunctionsCommand;
        ListFunctionEventInvokeConfigsCommand: typeof import("@aws-sdk/client-lambda").ListFunctionEventInvokeConfigsCommand;
        GetFunctionConfigurationCommand: typeof import("@aws-sdk/client-lambda").GetFunctionConfigurationCommand;
        GetAccountSettingsCommand: typeof import("@aws-sdk/client-lambda").GetAccountSettingsCommand;
    };
};
export default _default;
//# sourceMappingURL=aws.d.ts.map