import { ListTagsCommand } from "@aws-sdk/client-lambda";
import { GetPolicyCommand } from "@aws-sdk/client-lambda";
import { ListLayersCommand } from "@aws-sdk/client-lambda";
import { ListEventSourceMappingsCommand } from "@aws-sdk/client-lambda";
import { GetFunctionCommand } from "@aws-sdk/client-lambda";
import { ListVersionsByFunctionCommand } from "@aws-sdk/client-lambda";
import { ListFunctionsCommand } from "@aws-sdk/client-lambda";
import { ListFunctionEventInvokeConfigsCommand } from "@aws-sdk/client-lambda";
import { GetFunctionConfigurationCommand } from "@aws-sdk/client-lambda";
import { GetAccountSettingsCommand } from "@aws-sdk/client-lambda";

import type { ListTagsCommandInput } from "@aws-sdk/client-lambda";
import type { GetPolicyCommandInput } from "@aws-sdk/client-lambda";
import type { ListLayersCommandInput } from "@aws-sdk/client-lambda";
import type { ListEventSourceMappingsCommandInput } from "@aws-sdk/client-lambda";
import type { GetFunctionCommandInput } from "@aws-sdk/client-lambda";
import type { ListVersionsByFunctionCommandInput } from "@aws-sdk/client-lambda";
import type { ListFunctionsCommandInput } from "@aws-sdk/client-lambda";
import type { ListFunctionEventInvokeConfigsCommandInput } from "@aws-sdk/client-lambda";
import type { GetFunctionConfigurationCommandInput } from "@aws-sdk/client-lambda";
import type { GetAccountSettingsCommandInput } from "@aws-sdk/client-lambda";

/// import type { ListTagsCommandOutput } from "@aws-sdk/client-lambda";
/// import type { GetPolicyCommandOutput } from "@aws-sdk/client-lambda";
/// import type { ListLayersCommandOutput } from "@aws-sdk/client-lambda";
/// import type { ListEventSourceMappingsCommandOutput } from "@aws-sdk/client-lambda";
/// import type { GetFunctionCommandOutput } from "@aws-sdk/client-lambda";
/// import type { ListVersionsByFunctionCommandOutput } from "@aws-sdk/client-lambda";
/// import type { ListFunctionsCommandOutput } from "@aws-sdk/client-lambda";
/// import type { ListFunctionEventInvokeConfigsCommandOutput } from "@aws-sdk/client-lambda";
/// import type { GetFunctionConfigurationCommandOutput } from "@aws-sdk/client-lambda";
/// import type { GetAccountSettingsCommandOutput } from "@aws-sdk/client-lambda";

/*** @constructor */
export function Command(this: Constructor) {
    return new class implements Object {} as Constructor;
}

Command.prototype.ListTagsCommand = (input: ListTagsCommandInput) => new ListTagsCommand(input);
Command.prototype.GetPolicyCommand = (input: GetPolicyCommandInput) => new GetPolicyCommand(input);
Command.prototype.ListLayersCommand = (input: ListLayersCommandInput) => new ListLayersCommand(input);
Command.prototype.ListEventSourceMappingsCommand = (input: ListEventSourceMappingsCommandInput) => new ListEventSourceMappingsCommand(input);
Command.prototype.GetFunctionCommand = (input: GetFunctionCommandInput) => new GetFunctionCommand(input);
Command.prototype.ListVersionsByFunctionCommand = (input: ListVersionsByFunctionCommandInput) => new ListVersionsByFunctionCommand(input);
Command.prototype.ListFunctionsCommand = (input: ListFunctionsCommandInput) => new ListFunctionsCommand(input);
Command.prototype.ListFunctionEventInvokeConfigsCommand = (input: ListFunctionEventInvokeConfigsCommandInput) => new ListFunctionEventInvokeConfigsCommand(input);
Command.prototype.GetFunctionConfigurationCommand = (input: GetFunctionConfigurationCommandInput) => new GetFunctionConfigurationCommand(input);
Command.prototype.GetAccountSettingsCommand = (input: GetAccountSettingsCommandInput) => new GetAccountSettingsCommand(input);

export interface Constructor {
    ListTagsCommand: (input: ListTagsCommandInput) => ListTagsCommand;
    GetPolicyCommand: (input: GetPolicyCommandInput) => GetPolicyCommand;
    ListLayersCommand: (input: ListLayersCommandInput) => ListLayersCommand;
    ListEventSourceMappingsCommand: (input: ListEventSourceMappingsCommandInput) => ListEventSourceMappingsCommand;
    GetFunctionCommand: (input: GetFunctionCommandInput) => GetFunctionCommand;
    ListVersionsByFunctionCommand: (input: ListVersionsByFunctionCommandInput) => ListVersionsByFunctionCommand;
    ListFunctionsCommand: (input: ListFunctionsCommandInput) => ListFunctionsCommand;
    ListFunctionEventInvokeConfigsCommand: (input: ListFunctionEventInvokeConfigsCommandInput) => ListFunctionEventInvokeConfigsCommand;
    GetFunctionConfigurationCommand: (input: GetFunctionConfigurationCommandInput) => GetFunctionConfigurationCommand;
    GetAccountSettingsCommand: (input: GetAccountSettingsCommandInput) => GetAccountSettingsCommand;
}

const Interface: Constructor = new Proxy(Command.prototype, Object.getPrototypeOf(Command));

export { Interface };
export default Interface;
