import { Client } from "./aws.js";
import { Functions } from "./function.js";
/***
 * AWS Lambda Service Interface
 * ---
 *
 * While the `Client` defines and wraps the profile + credentials,
 * and initializes the `*.commands` attribute(s), `Service` extends
 * usage to AWS' Lambda API.
 *
 * @see {@link Client}
 *
 * @example
 */
declare class Service extends Client {
    constructor(profile?: string);
    /***
     * List all AWS Account Lambda Functions(s)
     */
    functions(debug?: boolean): Promise<Functions>;
}
export { Service };
declare const _default: {
    Service: typeof Service;
};
export default _default;
//# sourceMappingURL=service.d.ts.map